ReadBeo:	;L signal an IRIN wurde erkannt !
		rcall	SetPower_ON
		rcall	STimer0_BREAK

		clr	TempL1
		out	TCNT0,TempL1	;Counter0 = 0
		inc	TempL1
		inc	TempL1
		out	TCCR0,TempL1	;ZeitMessung Starten
		ldi	Timer,TimerMax	;Max Time

		ldi	TempU1,21	;Anzahl der Bits
		PushZ
		ldiw	X,BeoReadBits
		ldiw_m	Z,BeoBitTimes
Beo_Next_Bit:	
Beo_Wait_H:	;auf H-Warten und in der (L)Zeit messen
		tst	Timer
		breq	Beo_Error
		sbis	PInC,IRIN_Bit	;auf H warten
		rjmp	Beo_Wait_H
		;jetzt H-Zeit (Bitlnge) messen
Beo_Time_Loop:	tst	Timer		;Zeitberlauf ?? (Timer stoppt automatisch !!)
		breq	Beo_Error
		sbic	PInC,IRIN_Bit	;messen bis L
		rjmp	Beo_Time_Loop
	;H-Zeit zu Ende ...
		mov	WorkU,Timer	;Timer-Wert sichern
		clr	TempL1
		out	TCNT0,TempL1	;Counter0 = 0
		ldi	Timer,TimerMax	;maximalwert
		lpm	;(Z) -> r0
		ld	TempL1,Z+	;***** Y=Y+1 *****
		mov	TempL1,r0	;vergleichswert laden
		tst	TempL1		;=0 ,dann Einzelbitauswertung
		breq	Beo_Bitauswert
		sub	WorkU,TempL1	;Zeitdifferenz
		sbrc	WorkU,7		;negativ ??
		neg	WorkU
		cpi	WorkU,BeoMaxDiff+1
		brcc	Beo_Error
Beo_Bit_Ok:	dec	TempU1
		brne	Beo_Next_Bit
		clr	TempL1
		out	TCCR0,TempL1	;Zeitmessung stoppen		
		rjmp	Beo_Read_Ok
Beo_Error:	clt
		PopZ			;T=0 -> FEHLER
		ret
Beo_Bitauswert:	;WorkU enthlt Timerwert
		clr	TempL1
Beo_Bit_T0:	ldi	TempU2,TimerMax-BeoBit0Time+BeoMaxDiff
		cp	TempU2,WorkU	
		brcs	Beo_Error	;Zeit kleiner als kleinste BitZeit
		cpi	WorkU,TimerMax-BeoBit0Time-BeoMaxDiff
		brcs	Beo_Bit_T1
		st	X+,TempL1	;Bit=0
		rjmp	Beo_Bit_Ok
Beo_Bit_T1:	inc	TempL1
		ldi	TempU2,TimerMax-BeoBit1Time+BeoMaxDiff
		cp	TempU2,WorkU
		brcs	Beo_Error
		cpi	WorkU,TimerMax-BeoBit1Time-BeoMaxDiff
		brcs	Beo_Bit_T2
		st	X+,TempL1	;Bit=1
		rjmp	Beo_Bit_Ok
Beo_Bit_T2:	inc	TempL1
		ldi	TempU2,TimerMax-BeoBit2Time+BeoMaxDiff
		cp	TempU2,WorkU
		brcs	Beo_Error
		cpi	WorkU,TimerMax-BeoBit2Time-BeoMaxDiff
		brcs	Beo_Error
		st	X+,TempL1	;Bit=2
		rjmp	Beo_Bit_Ok
Beo_Read_Ok:	;Gertecode ermitteln
		ldiw	X,BeoReadBits
		ldi	TempU1,6
		clr	Y_L
		clr	Y_H
		clr	TempL2
Beo_Dev_Loop:	ld	TempL1,X+
		mov_w	Z,Y
		add	Y_L,Y_L
		adc	Y_H,Y_H		;CY-ADD *2
		add	Y_L,Z_L
		adc	Y_H,Z_H		;CY-ADD *3
		add	Y_L,TempL1
		adc	Y_H,TempL2	;CY-ADD
		dec	TempU1
		brne	Beo_Dev_Loop
		stsw	DevCode,Y	;Gertecode in Y
		;Tastencode ermitteln
		ldi	TempU1,7							
		clr	Y_L
		clr	Y_H
Beo_Key_Loop:	ld	TempL1,X+
		mov_w	Z,Y
		add	Y_L,Y_L
		adc	Y_H,Y_H		;CY-ADD *2
		add	Y_L,Z_L
		adc	Y_H,Z_H		;CY-ADD *3
		add	Y_L,TempL1
		adc	Y_H,TempL2	;CY-ADD
		dec	TempU1
		brne	Beo_Key_Loop
		stsw	KeyCode,Y	;Tastencode in Y
		PopZ
	;StatusLED EIN
	ldi	TempU1,11		;1sec
	mov	Status_Cnt,TempU1
	cbi	PORTA,Status_Bit	;LED ein
	
		rcall	Get_Taste
		rjmp	Get_Geraet	
		;ret

BeoBitTimes:	;* 3;3;15;3;6;6;6;xxx;12
		.db	56,56,8,56,44,44,44,0,0,0,0,0,0,0,0,0,0,0,0,0,20
